# Mask User Data

*IMPORTANT: Do not use this module on a production environment.*

This module will mask all the current data in your database related to the 
users. By default it will try to mask the default fields created by Drupal, 
but this can easily be extended providing a mapping for other fields. 


## Dependencies

* Libraries API 2.x - https://drupal.org/project/libraries
* Faker library - https://github.com/fzaninotto/Faker/releases
* PHP 5.4+ is required. 


## Installation

1) Install Libraries version 2.x from http://drupal.org/project/libraries.

2) Install the PHP Faker library.
  
  a) If you have drush, you can install Faker with this command (executed
    from the root folder of your Drupal codebase):
    
    `drush make --no-core sites/all/modules/mask_user_data/mask_user_data.make`
  
  b) If you don't have drush, download the library from here:
    https://github.com/fzaninotto/Faker/archive/v1.7.0.zip
    Extract that zip file into your Drupal codebase's
    sites/all/libraries/faker folder such that the path to autoload.php
    is: sites/all/libraries/faker/src/autoload.php


## Set up and usage

After enabling the module you need to click on another enable checkbox to
make sure that the module is not turned on by accident. This setting can be set
in _settings.php_.

It uses the PHP library [Faker](https://github.com/fzaninotto/Faker) and each
user field or property can map to a Faker function (ie: _mail_ maps to _email_,
_field_phone_ maps to _phoneNumber_, etc.). This can be defined in:
* _settings.php_ using _$conf['mask_user_data_map_array'] = array(...)_.
* Via the UI.

Once the module is enabled and the mapping is done there is only one thing
to do, run the drush command: `drush mud`  

An automatic deployment could look like this (assuming you have aliases set up): 
* drush -y sql-drop
* drush -y sql-sync @prod default
* drush -y en mask_user_data
* drush -y mud


## TODO

* Tests.
* Dynamic form to map fields.
* Drupal 8 version.
